--[[
Entire script by ChrisFurry.
Welcome to version 3A, I messed up my mod code
I've learned a lot about lua since the last update so things are going to be different, sorry.
]]--
if(rawget(_G,"animatedskincolor_api2"))then 
	-- Sorry for my dumb print that could confuse people who add multiple mods that use this script
	return 
end

-- Define the namespace
local asc = {
	tics = 0,
	colors = {},
}

---@param color_id SKIN_COLOR
---@param tic_delay tic_t The delay between ramp changes. (Default 4)
---@return namespace, for chaining
function asc.setDelay(color_id,tic_delay)
	asc.makeAnimated(color_id,tic_delay)
	return asc
end

---@param color_id SKIN_COLOR
---@return Animated Color table.
function asc.get(color_id) return asc.colors[color_id] end

---@param color_id SKIN_COLOR
---@return Animated Color's current ramp.
function asc.getRamp(color_id) 
	if(asc.colors[color_id] and #asc.colors[color_id].ramp)then
		local r,t = asc.colors[color_id].ramp,asc.colors[color_id].delay
		if(asc.tics <= 0)then return r[1] end
		return r[(asc.tics / t % #r) + 1]
	end
	return nil
end

---@param color_id SKIN_COLOR The skin color you want to become animated.
---@param tic_delay tic_t The delay between ramp changes. (Default 4)
---@return namespace, for chaining
function asc.makeAnimated(color_id,tic_delay)
	if(asc.colors[color_id])then
		asc.colors[color_id].delay = tic_delay
		return asc
	end
	tic_delay = tic_delay or 4
	asc.colors[color_id] = {
		ramp = {},
		delay = tic_delay
	}
	return asc
end

---@param color_id SKIN_COLOR The skin color you want to add a ramp to.
---@param ramp table The color ramp you want to add to the animation.
---@param ... table Color ramps.
---@return namespace, for chaining
function asc.addRamp(color_id,ramp,...)
	if(type(ramp) ~= "table")then return asc end
	if(asc.colors[color_id] == nil)then asc.makeAnimated(color_id) end
	table.insert(asc.colors[color_id].ramp,ramp)
	if(#asc.colors[color_id].ramp == 1)then skincolors[color_id].ramp = ramp end
	return asc.addRamp(color_id,...)
end

-- Animates skin colors.
function asc.think()
	asc.tics = $+1
	for sc,data in pairs(asc.colors) do
		if(asc.colors[sc])then
			skincolors[sc].ramp = asc.getRamp(sc) or skincolors[sc].ramp
		end
	end
end
-- Resets the timer, used so when you go into a replay or smth the color will appear exact as it was.
function asc.resetTimer() asc.tics = 0 end

-- Hooks
addHook("PostThinkFrame",asc.think)
addHook("IntermissionThinker",asc.think)
addHook("VoteThinker",asc.think)
addHook("MapChange",asc.resetTimer)

-- Make the namespace is global so other scripts can use it.

rawset(_G,"animatedSkinColor",asc)
rawset(_G,"animatedskincolor_api2",true)


--#############################
--#  STAPLER PACK EDITS BELOW #
--#############################

freeslot("SKINCOLOR_KODACHROME")
skincolors[SKINCOLOR_KODACHROME] = {
name = "Kodachrome Void",
ramp = {3,6,9,13,16,19,23,26,3,6,9,13,16,19,23,26},
invcolor = SKINCOLOR_GARDEN,
invshade = 0,
chatcolor = V_GRAYMAP,
accessible = true}
-- Make animated & Add Ramps
animatedSkinColor.makeAnimated(SKINCOLOR_KODACHROME,5).addRamp(SKINCOLOR_KODACHROME,
{3  ,6  ,9  ,13 ,16 ,19 ,23 ,26 ,3  ,6  ,9  ,13 ,16 ,19 ,23 ,26 },
{6  ,9  ,13 ,16 ,19 ,23 ,26 ,3  ,6  ,9  ,13 ,16 ,19 ,23 ,26 ,3  },
{9  ,13 ,16 ,19 ,23 ,26 ,3  ,6  ,9  ,13 ,16 ,19 ,23 ,26 ,3  ,6  },
{13 ,16 ,19 ,23 ,26 ,3  ,6  ,9  ,13 ,16 ,19 ,23 ,26 ,3  ,6  ,9  },
{16 ,19 ,23 ,26 ,3  ,6  ,9  ,13 ,16 ,19 ,23 ,26 ,3  ,6  ,9  ,13 },
{19 ,23 ,26 ,3  ,6  ,9  ,13 ,16 ,19 ,23 ,26 ,3  ,6  ,9  ,13 ,16 },
{23 ,26 ,3  ,6  ,9  ,13 ,16 ,19 ,23 ,26 ,3  ,6  ,9  ,13 ,16 ,19 },
{26 ,3  ,6  ,9  ,13 ,16 ,19 ,23 ,26 ,3  ,6  ,9  ,13 ,16 ,19 ,23 })



freeslot("SKINCOLOR_TERAVOLT")
skincolors[SKINCOLOR_TERAVOLT] = {
name = "Teravolt",
ramp = {129,255,255,255,135,136,139,139,27,28,28,28,28,29,30,31},
invcolor = SKINCOLOR_WHITE,
invshade = 0,
chatcolor = V_GRAYMAP,
accessible = true}
-- Make animated & Add Ramps
animatedSkinColor.makeAnimated(SKINCOLOR_TERAVOLT,3).addRamp(SKINCOLOR_TERAVOLT,
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,134,135,137,139,27 ,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{130,255,141,136,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{140,141,141,137,138,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{142,142,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{137,137,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
{139,139,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
-- end of loop
{137,137,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
{137,137,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
{142,142,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{140,141,141,137,138,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{130,255,141,136,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,134,135,137,139,27 ,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
-- end of second loop
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,134,135,137,139,27 ,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{130,255,141,136,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{140,141,141,137,138,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{142,142,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{137,137,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
{139,139,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
-- end of loop 2
{137,137,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
{137,137,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
{142,142,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{140,141,141,137,138,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{130,255,141,136,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,134,135,137,139,27 ,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
-- end of second loop 2
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,134,135,137,139,27 ,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{130,255,141,136,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{140,141,141,137,138,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{142,142,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{137,137,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
{139,139,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
-- end of loop 3
{137,137,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
{137,137,139,28 ,28 ,28 ,29 ,29 ,30 ,30 ,31 ,31 ,31 ,31 ,31 ,31 },
{142,142,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{140,141,141,137,138,139,28 ,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{130,255,141,136,137,139,139,28 ,28 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,134,135,137,139,27 ,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
-- end of second loop 3
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 },
{129,255,255,255,135,136,139,139,27 ,28 ,28 ,28 ,28 ,29 ,30 ,31 })
